<script>
    import { goto } from '@sapper/app'
    import Header from 'components/Header.svelte'
    import Spinner from 'components/Icons/Spinner.svelte'
    import { post } from 'lib/fetch'
    import { validateSelf } from 'lib/validate'
    import { awaitingAPI } from 'store'

    let content
    let errors

    const validate = async () => {
        errors = await validateSelf(['required', 'min:1'], content)
        return errors.length === 0
    }

    const publish = async () => {
        if (!(await validate)) return

        const { req } = await post('/api/posts', { content })
        if (req.ok) {
            await goto('/')
        }
    }
</script>

<Header withBorder={false} />

<section>
    <header>
        <button class="link" on:click={() => window.history.back()}
            >Annuler</button
        >
        <button class="button" on:click={publish}>
            {#if $awaitingAPI}
                <Spinner />
            {:else}
                Publier
            {/if}
        </button>
    </header>
    <main>
        <textarea placeholder="Quoi de neuf ?" bind:value={content} autofocus />
    </main>
</section>

<style lang="postcss">
    section {
        @apply px-4 overflow-y-auto flex flex-col;

        header {
            @apply flex justify-between mb-3;

            .link {
                @apply text-teal-500;
            }

            .button {
                @apply text-teal-50 bg-teal-500 rounded-full px-4 py-1;
            }
        }

        main {
            @apply flex gap-x-2 flex-1;

            textarea {
                @apply resize-none w-full text-lg mt-1;

                &::placeholder {
                    @apply text-blueGray-500 opacity-100;

                    &:focus {
                        @apply outline-none;
                    }
                }
            }
        }
    }
</style>
